"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _logger = _interopRequireDefault(require("../../../../scripts/utils/logger"));

/**
 * Hides the blinking input caret that appears within editable text areas to prevent inconsistent test failures.
 *
 * @param {string} selector The selector for the element to hide the caret of
 */
var hideInputCaret = function hideInputCaret(selector) {
  try {
    global.browser.execute("document.querySelector(\"".concat(selector.replace(/"/g, '\\"'), "\").style.caretColor = \"transparent\";"));
  } catch (error) {
    if (!global.browser.isExisting(selector)) {
      throw _logger.default.error("No element could be found with the selector '".concat(selector, "'."));
    } else {
      throw new Error(error);
    }
  }
};

var _default = hideInputCaret;
exports.default = _default;